#include "nsIStandardURL.h"
#include "nsIURL.h"
#include "nsIFileURL.h"
#include "nsISerializable.h"
#include "nsIClassInfo.h"
#include "nsIIOService2.h"
#include "nsINetUtil.h"
#include "nsIObserver.h"
#include "nsIWeakReference.h"
#include "nsIChannel.h"
#include "nsIInterfaceRequestor.h"
#include "nsITransport.h"
#include "nsIStreamListener.h"
#include "nsISocketTransportService.h"
#include "nsIEventTarget.h"
#include "nsIThreadInternal.h"
#include "nsIRunnable.h"
#include "nsPISocketTransportService.h"
#include "nsISocketTransport.h"
#include "nsIDNSListener.h"
#include "nsIMutableArray.h"
#include "nsIProperty.h"
#include "nsIINIParser.h"
#include "nsIFactory.h"
#include "nsIVariant.h"
#include "nsIPersistentProperties2.h"
#include "nsISimpleEnumerator.h"
#include "nsIStringEnumerator.h"
#include "nsISupportsArray.h"
#include "nsISerializable.h"
#include "nsIAtom.h"
#include "nsISupportsPrimitives.h"
#include "nsIWritablePropertyBag.h"
#include "nsIWritablePropertyBag2.h"
#include "nsArray.h"
#include "nsIByteBuffer.h"
#include "nsHashPropertyBag.h"
#include "nsINIParserImpl.h"
#include "nsVariant.h"
#include "nsByteBuffer.h"
#include "nsPersistentProperties.h"
#include "nsUnicharBuffer.h"
#include "nsObserverList.h"
#include "nsStringEnumerator.h"
#include "nsSupportsArray.h"
#include "nsAtomTable.h"
#include "nsStaticAtom.h"
#include "nsSupportsArrayEnumerator.h"
#include "nsSupportsPrimitives.h"
#include "nsStandardURL.h"
#include "nsIOService.h"
#include "nsBaseChannel.h"
#include "nsSocketTransportService2.h"
#include "nsSocketTransport2.h"
NS_IMPL_CI_INTERFACE_GETTER3(nsSocketTransport,
nsISocketTransport,
nsITransport,
nsIDNSListener)

    enum nsIOService_QIActionType {
      nsIOService_OFFSET_THIS_ADDREF
    };

    struct nsIOService_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsIOService::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        1,
0,
4,
2,
5,
0xFF,
0xFF,
3
#else
        1,
0,
4,
2,
5,
0xFF,
0xFF,
3
#endif
      };

      static const nsIOService_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsIObserver)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIObserver*>(static_cast<nsIOService*>(((nsIOService*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsIOService*>(((nsIOService*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsIIOService*>(static_cast<nsIOService*>(((nsIOService*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsIOService*>(((nsIOService*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIIOService2)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIIOService2*>(static_cast<nsIOService*>(((nsIOService*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsIOService*>(((nsIOService*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIIOService)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIIOService*>(static_cast<nsIOService*>(((nsIOService*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsIOService*>(((nsIOService*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupportsWeakReference)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsWeakReference*>(static_cast<nsIOService*>(((nsIOService*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsIOService*>(((nsIOService*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsINetUtil)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsINetUtil*>(static_cast<nsIOService*>(((nsIOService*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsIOService*>(((nsIOService*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsIOService_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c0000) >> 18;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c0000) >> 18;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_THREADSAFE_ADDREF(nsIOService)
    NS_IMPL_THREADSAFE_RELEASE(nsIOService)
    

    enum nsStandardURL_QIActionType {
      nsStandardURL_OFFSET_THIS_ADDREF, nsStandardURL_NS_CONDITIONAL_nsIFileURL
    };

    struct nsStandardURL_QIAction {
      const nsID *iid;
      nsStandardURL_QIActionType action;
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsStandardURL::QueryInterface(REFNSIID aIID, void **aResult)
    {
      
        static const nsID kGQI_NS_THIS_STANDARDURL_IMPL_CID = { 0xb8e3e97b, 0x1ccd, 0x4b45, { 0xaf, 0x5a, 0x79, 0x59, 0x67, 0x70, 0xf5, 0xd7 } };
        #ifdef DEBUG
        static const nsID kGQI_TEST_NS_THIS_STANDARDURL_IMPL_CID = NS_THIS_STANDARDURL_IMPL_CID;
        #endif
        NS_ASSERTION(kGQI_NS_THIS_STANDARDURL_IMPL_CID.Equals(kGQI_TEST_NS_THIS_STANDARDURL_IMPL_CID),
                     "GQI pseudo-IID doesn't match reality.");
        

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        4,
0xFF,
3,
0xFF,
5,
0xFF,
0xFF,
1,
0xFF,
0xFF,
2,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF,
0,
0xFF,
6,
7,
8,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF
#else
        4,
0xFF,
3,
0xFF,
5,
0xFF,
0xFF,
1,
0xFF,
0xFF,
2,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF,
0,
0xFF,
6,
7,
8,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF
#endif
      };

      static const nsStandardURL_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsIFileURL)),
          nsStandardURL_NS_CONDITIONAL_nsIFileURL,
          {0}
        },
    
        {
          &(kGQI_NS_THIS_STANDARDURL_IMPL_CID),
          nsStandardURL_OFFSET_THIS_ADDREF,
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsStandardURL*>(static_cast<nsStandardURL*>(((nsStandardURL*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsStandardURL*>(((nsStandardURL*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIMutable)),
          nsStandardURL_OFFSET_THIS_ADDREF,
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIMutable*>(static_cast<nsStandardURL*>(((nsStandardURL*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsStandardURL*>(((nsStandardURL*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIURL)),
          nsStandardURL_OFFSET_THIS_ADDREF,
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIURL*>(static_cast<nsStandardURL*>(((nsStandardURL*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsStandardURL*>(((nsStandardURL*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          nsStandardURL_OFFSET_THIS_ADDREF,
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsIStandardURL*>(static_cast<nsStandardURL*>(((nsStandardURL*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsStandardURL*>(((nsStandardURL*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIURI)),
          nsStandardURL_OFFSET_THIS_ADDREF,
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIURI*>(static_cast<nsStandardURL*>(((nsStandardURL*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsStandardURL*>(((nsStandardURL*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIClassInfo)),
          nsStandardURL_OFFSET_THIS_ADDREF,
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIClassInfo*>(static_cast<nsStandardURL*>(((nsStandardURL*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsStandardURL*>(((nsStandardURL*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISerializable)),
          nsStandardURL_OFFSET_THIS_ADDREF,
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISerializable*>(static_cast<nsStandardURL*>(((nsStandardURL*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsStandardURL*>(((nsStandardURL*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIStandardURL)),
          nsStandardURL_OFFSET_THIS_ADDREF,
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIStandardURL*>(static_cast<nsStandardURL*>(((nsStandardURL*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsStandardURL*>(((nsStandardURL*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsStandardURL_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0xf8000) >> 15;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0xf8000) >> 15;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
      switch (entry->action) {
      
      case nsStandardURL_OFFSET_THIS_ADDREF:
        
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    
    
      case nsStandardURL_NS_CONDITIONAL_nsIFileURL:
        
        if (!(mSupportsFileURL)) {
            goto unfound;
        }
        found = static_cast<nsIFileURL*>(this);
        goto exit_addref;
        
    
      }
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    enum nsSocketTransportService_QIActionType {
      nsSocketTransportService_OFFSET_THIS_ADDREF
    };

    struct nsSocketTransportService_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsSocketTransportService::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        1,
0xFF,
4,
5,
2,
3,
0,
0xFF
#else
        1,
0xFF,
4,
5,
2,
3,
0,
0xFF
#endif
      };

      static const nsSocketTransportService_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsPISocketTransportService)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsPISocketTransportService*>(static_cast<nsSocketTransportService*>(((nsSocketTransportService*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSocketTransportService*>(((nsSocketTransportService*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsISocketTransportService*>(static_cast<nsSocketTransportService*>(((nsSocketTransportService*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsSocketTransportService*>(((nsSocketTransportService*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISocketTransportService)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISocketTransportService*>(static_cast<nsSocketTransportService*>(((nsSocketTransportService*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSocketTransportService*>(((nsSocketTransportService*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIThreadObserver)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIThreadObserver*>(static_cast<nsSocketTransportService*>(((nsSocketTransportService*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSocketTransportService*>(((nsSocketTransportService*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIRunnable)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIRunnable*>(static_cast<nsSocketTransportService*>(((nsSocketTransportService*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSocketTransportService*>(((nsSocketTransportService*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIEventTarget)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIEventTarget*>(static_cast<nsSocketTransportService*>(((nsSocketTransportService*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSocketTransportService*>(((nsSocketTransportService*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsSocketTransportService_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x700) >> 8;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x700) >> 8;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_THREADSAFE_ADDREF(nsSocketTransportService)
    NS_IMPL_THREADSAFE_RELEASE(nsSocketTransportService)
    

    enum nsBaseChannel_QIActionType {
      nsBaseChannel_OFFSET_THIS_ADDREF
    };

    struct nsBaseChannel_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsBaseChannel::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        4,
5,
0xFF,
2,
0xFF,
0xFF,
0xFF,
0xFF,
10,
7,
0,
0xFF,
1,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF,
8,
0xFF,
0xFF,
0xFF,
9,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF,
3,
6,
0xFF
#else
        4,
5,
0xFF,
2,
0xFF,
0xFF,
0xFF,
0xFF,
10,
7,
0,
0xFF,
1,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF,
8,
0xFF,
0xFF,
0xFF,
9,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF,
3,
6,
0xFF
#endif
      };

      static const nsBaseChannel_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsIChannel)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIChannel*>(static_cast<nsBaseChannel*>(((nsBaseChannel*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsBaseChannel*>(((nsBaseChannel*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIWritablePropertyBag2)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIWritablePropertyBag2*>(static_cast<nsHashPropertyBag*>(static_cast<nsBaseChannel*>(((nsBaseChannel*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsHashPropertyBag*>(static_cast<nsBaseChannel*>(((nsBaseChannel*) 0x1000)))))
   }
        },
    
        {
          &(NS_GET_IID(nsIInterfaceRequestor)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIInterfaceRequestor*>(static_cast<nsBaseChannel*>(((nsBaseChannel*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsBaseChannel*>(((nsBaseChannel*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIPropertyBag)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIPropertyBag*>(
           static_cast<nsIWritablePropertyBag*>(static_cast<nsHashPropertyBag*>(static_cast<nsBaseChannel*>(((nsBaseChannel*) 0x1000)))))) -
       reinterpret_cast<char*>(static_cast<nsHashPropertyBag*>(static_cast<nsBaseChannel*>(((nsBaseChannel*) 0x1000)))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsIRequest*>(static_cast<nsBaseChannel*>(((nsBaseChannel*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsBaseChannel*>(((nsBaseChannel*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIStreamListener)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIStreamListener*>(static_cast<nsBaseChannel*>(((nsBaseChannel*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsBaseChannel*>(((nsBaseChannel*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIRequest)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIRequest*>(static_cast<nsBaseChannel*>(((nsBaseChannel*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsBaseChannel*>(((nsBaseChannel*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsITransportEventSink)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsITransportEventSink*>(static_cast<nsBaseChannel*>(((nsBaseChannel*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsBaseChannel*>(((nsBaseChannel*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIWritablePropertyBag)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIWritablePropertyBag*>(static_cast<nsHashPropertyBag*>(static_cast<nsBaseChannel*>(((nsBaseChannel*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsHashPropertyBag*>(static_cast<nsBaseChannel*>(((nsBaseChannel*) 0x1000)))))
   }
        },
    
        {
          &(NS_GET_IID(nsIRequestObserver)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIRequestObserver*>(static_cast<nsBaseChannel*>(((nsBaseChannel*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsBaseChannel*>(((nsBaseChannel*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIPropertyBag2)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIPropertyBag2*>(static_cast<nsHashPropertyBag*>(static_cast<nsBaseChannel*>(((nsBaseChannel*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsHashPropertyBag*>(static_cast<nsBaseChannel*>(((nsBaseChannel*) 0x1000)))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsBaseChannel_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x3e0) >> 5;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x3e0) >> 5;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(nsBaseChannel)
    NS_IMPL_RELEASE(nsBaseChannel)
    

    enum nsSocketTransport_QIActionType {
      nsSocketTransport_OFFSET_THIS_ADDREF
    };

    struct nsSocketTransport_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsSocketTransport::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        1,
2,
3,
0xFF,
4,
0xFF,
0xFF,
0
#else
        1,
2,
3,
0xFF,
4,
0xFF,
0xFF,
0
#endif
      };

      static const nsSocketTransport_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsIDNSListener)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIDNSListener*>(static_cast<nsSocketTransport*>(((nsSocketTransport*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSocketTransport*>(((nsSocketTransport*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsISocketTransport*>(static_cast<nsSocketTransport*>(((nsSocketTransport*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsSocketTransport*>(((nsSocketTransport*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsITransport)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsITransport*>(static_cast<nsSocketTransport*>(((nsSocketTransport*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSocketTransport*>(((nsSocketTransport*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISocketTransport)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISocketTransport*>(static_cast<nsSocketTransport*>(((nsSocketTransport*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSocketTransport*>(((nsSocketTransport*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIClassInfo)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIClassInfo*>(static_cast<nsSocketTransport*>(((nsSocketTransport*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSocketTransport*>(((nsSocketTransport*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsSocketTransport_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_THREADSAFE_ADDREF(nsSocketTransport)
    NS_IMPL_THREADSAFE_RELEASE(nsSocketTransport)
    
