#include "nsIEnumerator.h"
#include "nsIComponentManager.h"
#include "nsIServiceManager.h"
#include "nsIWeakReference.h"
#include "nsIInterfaceRequestor.h"
#include "nsIComponentRegistrar.h"
#include "nsIComponentManagerObsolete.h"
#include "nsIStringEnumerator.h"
#include "nsIModuleLoader.h"
#include "nsICategoryManager.h"
#include "nsComponentManager.h"
#include "nsCategoryManager.h"
#include "nsNativeComponentLoader.h"

    enum nsCategoryManager_QIActionType {
      nsCategoryManager_OFFSET_THIS_ADDREF
    };

    struct nsCategoryManager_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsCategoryManager::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        1,
0xFF,
0xFF,
0xFF,
0xFF,
0,
0xFF,
0xFF
#else
        1,
0xFF,
0xFF,
0xFF,
0xFF,
0,
0xFF,
0xFF
#endif
      };

      static const nsCategoryManager_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsICategoryManager)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsICategoryManager*>(static_cast<nsCategoryManager*>(((nsCategoryManager*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsCategoryManager*>(((nsCategoryManager*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsICategoryManager*>(static_cast<nsCategoryManager*>(((nsCategoryManager*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsCategoryManager*>(((nsCategoryManager*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsCategoryManager_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x7) >> 0;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x7) >> 0;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_THREADSAFE_ADDREF(nsCategoryManager)
    NS_IMPL_THREADSAFE_RELEASE(nsCategoryManager)
    

    enum PLDHashTableEnumeratorImpl_QIActionType {
      PLDHashTableEnumeratorImpl_OFFSET_THIS_ADDREF
    };

    struct PLDHashTableEnumeratorImpl_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP PLDHashTableEnumeratorImpl::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        1,
0xFF,
0,
0xFF,
2,
3,
0xFF,
0xFF
#else
        1,
0xFF,
0,
0xFF,
2,
3,
0xFF,
0xFF
#endif
      };

      static const PLDHashTableEnumeratorImpl_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISimpleEnumerator)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISimpleEnumerator*>(static_cast<PLDHashTableEnumeratorImpl*>(((PLDHashTableEnumeratorImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<PLDHashTableEnumeratorImpl*>(((PLDHashTableEnumeratorImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsIBidirectionalEnumerator*>(static_cast<PLDHashTableEnumeratorImpl*>(((PLDHashTableEnumeratorImpl*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<PLDHashTableEnumeratorImpl*>(((PLDHashTableEnumeratorImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIEnumerator)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIEnumerator*>(static_cast<PLDHashTableEnumeratorImpl*>(((PLDHashTableEnumeratorImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<PLDHashTableEnumeratorImpl*>(((PLDHashTableEnumeratorImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIBidirectionalEnumerator)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIBidirectionalEnumerator*>(static_cast<PLDHashTableEnumeratorImpl*>(((PLDHashTableEnumeratorImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<PLDHashTableEnumeratorImpl*>(((PLDHashTableEnumeratorImpl*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const PLDHashTableEnumeratorImpl_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0xe0) >> 5;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0xe0) >> 5;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(PLDHashTableEnumeratorImpl)
    NS_IMPL_RELEASE(PLDHashTableEnumeratorImpl)
    

    enum nsComponentManagerImpl_QIActionType {
      nsComponentManagerImpl_OFFSET_THIS_ADDREF
    };

    struct nsComponentManagerImpl_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsComponentManagerImpl::QueryInterface(REFNSIID aIID, void **aResult)
    {
      
        #ifdef DEBUG
        static const nsID kGQI_nsIServiceManagerObsolete = { 0xcf0df3b0, 0x3401, 0x11d2, { 0x81, 0x63, 0x00, 0x60, 0x08, 0x11, 0x9d, 0x7a } };
        NS_ASSERTION(NS_GET_IID(nsIServiceManagerObsolete).Equals(kGQI_nsIServiceManagerObsolete),
                     "GQI pseudo-IID doesn't match reality.");
        #endif
        

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        3,
0xFF,
0xFF,
0xFF,
5,
0xFF,
7,
1,
6,
0xFF,
0xFF,
4,
0xFF,
2,
0xFF,
0
#else
        3,
0xFF,
0xFF,
0xFF,
5,
0xFF,
7,
1,
6,
0xFF,
0xFF,
4,
0xFF,
2,
0xFF,
0
#endif
      };

      static const nsComponentManagerImpl_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsIComponentRegistrar)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIComponentRegistrar*>(static_cast<nsComponentManagerImpl*>(((nsComponentManagerImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsComponentManagerImpl*>(((nsComponentManagerImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIInterfaceRequestor)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIInterfaceRequestor*>(static_cast<nsComponentManagerImpl*>(((nsComponentManagerImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsComponentManagerImpl*>(((nsComponentManagerImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIServiceManager)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIServiceManager*>(static_cast<nsComponentManagerImpl*>(((nsComponentManagerImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsComponentManagerImpl*>(((nsComponentManagerImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsIComponentManager*>(static_cast<nsComponentManagerImpl*>(((nsComponentManagerImpl*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsComponentManagerImpl*>(((nsComponentManagerImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIServiceManagerObsolete)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIServiceManagerObsolete*>(static_cast<nsComponentManagerImpl*>(((nsComponentManagerImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsComponentManagerImpl*>(((nsComponentManagerImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIComponentManagerObsolete)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIComponentManagerObsolete*>(static_cast<nsComponentManagerImpl*>(((nsComponentManagerImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsComponentManagerImpl*>(((nsComponentManagerImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupportsWeakReference)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsWeakReference*>(static_cast<nsComponentManagerImpl*>(((nsComponentManagerImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsComponentManagerImpl*>(((nsComponentManagerImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIComponentManager)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIComponentManager*>(static_cast<nsComponentManagerImpl*>(((nsComponentManagerImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsComponentManagerImpl*>(((nsComponentManagerImpl*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsComponentManagerImpl_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0xf0) >> 4;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0xf0) >> 4;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_THREADSAFE_ADDREF(nsComponentManagerImpl)
    NS_IMPL_THREADSAFE_RELEASE(nsComponentManagerImpl)
    

    enum nsCategoryManagerFactory_QIActionType {
      nsCategoryManagerFactory_OFFSET_THIS_ADDREF
    };

    struct nsCategoryManagerFactory_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsCategoryManagerFactory::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        1,
0,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF
#else
        1,
0,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF
#endif
      };

      static const nsCategoryManagerFactory_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsIFactory)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIFactory*>(static_cast<nsCategoryManagerFactory*>(((nsCategoryManagerFactory*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsCategoryManagerFactory*>(((nsCategoryManagerFactory*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsIFactory*>(static_cast<nsCategoryManagerFactory*>(((nsCategoryManagerFactory*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsCategoryManagerFactory*>(((nsCategoryManagerFactory*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsCategoryManagerFactory_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x7) >> 0;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x7) >> 0;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(nsCategoryManagerFactory)
    NS_IMPL_RELEASE(nsCategoryManagerFactory)
    

    enum BaseStringEnumerator_QIActionType {
      BaseStringEnumerator_OFFSET_THIS_ADDREF
    };

    struct BaseStringEnumerator_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP BaseStringEnumerator::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        2,
1,
0xFF,
0xFF,
0,
0xFF,
0xFF,
0xFF
#else
        2,
1,
0xFF,
0xFF,
0,
0xFF,
0xFF,
0xFF
#endif
      };

      static const BaseStringEnumerator_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISimpleEnumerator)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISimpleEnumerator*>(static_cast<BaseStringEnumerator*>(((BaseStringEnumerator*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<BaseStringEnumerator*>(((BaseStringEnumerator*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIUTF8StringEnumerator)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIUTF8StringEnumerator*>(static_cast<BaseStringEnumerator*>(((BaseStringEnumerator*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<BaseStringEnumerator*>(((BaseStringEnumerator*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsISimpleEnumerator*>(static_cast<BaseStringEnumerator*>(((BaseStringEnumerator*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<BaseStringEnumerator*>(((BaseStringEnumerator*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const BaseStringEnumerator_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x70) >> 4;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x70) >> 4;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(BaseStringEnumerator)
    NS_IMPL_RELEASE(BaseStringEnumerator)
    

    enum nsNativeModuleLoader_QIActionType {
      nsNativeModuleLoader_OFFSET_THIS_ADDREF
    };

    struct nsNativeModuleLoader_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsNativeModuleLoader::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        1,
0xFF,
0xFF,
0xFF,
0,
0xFF,
0xFF,
0xFF
#else
        1,
0xFF,
0xFF,
0xFF,
0,
0xFF,
0xFF,
0xFF
#endif
      };

      static const nsNativeModuleLoader_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsIModuleLoader)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIModuleLoader*>(static_cast<nsNativeModuleLoader*>(((nsNativeModuleLoader*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsNativeModuleLoader*>(((nsNativeModuleLoader*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsIModuleLoader*>(static_cast<nsNativeModuleLoader*>(((nsNativeModuleLoader*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsNativeModuleLoader*>(((nsNativeModuleLoader*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsNativeModuleLoader_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x7) >> 0;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x7) >> 0;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }
