#include "nsIMutableArray.h"
#include "nsIProperty.h"
#include "nsIINIParser.h"
#include "nsIFactory.h"
#include "nsIVariant.h"
#include "nsIPersistentProperties2.h"
#include "nsISimpleEnumerator.h"
#include "nsIStringEnumerator.h"
#include "nsISupportsArray.h"
#include "nsISerializable.h"
#include "nsIAtom.h"
#include "nsISupportsPrimitives.h"
#include "nsIWritablePropertyBag.h"
#include "nsIWritablePropertyBag2.h"
#include "nsArray.h"
#include "nsIByteBuffer.h"
#include "nsHashPropertyBag.h"
#include "nsINIParserImpl.h"
#include "nsVariant.h"
#include "nsByteBuffer.h"
#include "nsPersistentProperties.h"
#include "nsUnicharBuffer.h"
#include "nsObserverList.h"
#include "nsStringEnumerator.h"
#include "nsSupportsArray.h"
#include "nsAtomTable.h"
#include "nsStaticAtom.h"
#include "nsSupportsArrayEnumerator.h"
#include "nsSupportsPrimitives.h"

    enum nsSupportsPRBoolImpl_QIActionType {
      nsSupportsPRBoolImpl_OFFSET_THIS_ADDREF
    };

    struct nsSupportsPRBoolImpl_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsSupportsPRBoolImpl::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        2,
0xFF,
0xFF,
0xFF,
1,
0,
0xFF,
0xFF
#else
        2,
0xFF,
0xFF,
0xFF,
1,
0,
0xFF,
0xFF
#endif
      };

      static const nsSupportsPRBoolImpl_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISupportsPrimitive)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPrimitive*>(static_cast<nsSupportsPRBoolImpl*>(((nsSupportsPRBoolImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRBoolImpl*>(((nsSupportsPRBoolImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupportsPRBool)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPRBool*>(static_cast<nsSupportsPRBoolImpl*>(((nsSupportsPRBoolImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRBoolImpl*>(((nsSupportsPRBoolImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsISupportsPRBool*>(static_cast<nsSupportsPRBoolImpl*>(((nsSupportsPRBoolImpl*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRBoolImpl*>(((nsSupportsPRBoolImpl*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsSupportsPRBoolImpl_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_THREADSAFE_ADDREF(nsSupportsPRBoolImpl)
    NS_IMPL_THREADSAFE_RELEASE(nsSupportsPRBoolImpl)
    

    enum nsSupportsArray_QIActionType {
      nsSupportsArray_OFFSET_THIS_ADDREF
    };

    struct nsSupportsArray_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsSupportsArray::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        2,
1,
0xFF,
0xFF,
3,
0,
0xFF,
0xFF
#else
        2,
1,
0xFF,
0xFF,
3,
0,
0xFF,
0xFF
#endif
      };

      static const nsSupportsArray_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISupportsArray)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsArray*>(static_cast<nsSupportsArray*>(((nsSupportsArray*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsArray*>(((nsSupportsArray*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISerializable)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISerializable*>(static_cast<nsSupportsArray*>(((nsSupportsArray*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsArray*>(((nsSupportsArray*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsISupportsArray*>(static_cast<nsSupportsArray*>(((nsSupportsArray*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsSupportsArray*>(((nsSupportsArray*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsICollection)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsICollection*>(static_cast<nsSupportsArray*>(((nsSupportsArray*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsArray*>(((nsSupportsArray*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsSupportsArray_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x38000) >> 15;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x38000) >> 15;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_THREADSAFE_ADDREF(nsSupportsArray)
    NS_IMPL_THREADSAFE_RELEASE(nsSupportsArray)
    

    enum UnicharBufferImpl_QIActionType {
      UnicharBufferImpl_OFFSET_THIS_ADDREF
    };

    struct UnicharBufferImpl_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP UnicharBufferImpl::QueryInterface(REFNSIID aIID, void **aResult)
    {
      
        #ifdef DEBUG
        static const nsID kGQI_nsIUnicharBuffer = { 0x14cf6970, 0x93b5, 0x11d1, { 0x89, 0x5b, 0x00, 0x60, 0x08, 0x91, 0x1b, 0x81 } };
        NS_ASSERTION(NS_GET_IID(nsIUnicharBuffer).Equals(kGQI_nsIUnicharBuffer),
                     "GQI pseudo-IID doesn't match reality.");
        #endif
        

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        0,
0xFF,
0xFF,
0xFF,
1,
0xFF,
0xFF,
0xFF
#else
        0,
0xFF,
0xFF,
0xFF,
1,
0xFF,
0xFF,
0xFF
#endif
      };

      static const UnicharBufferImpl_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsIUnicharBuffer*>(static_cast<UnicharBufferImpl*>(((UnicharBufferImpl*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<UnicharBufferImpl*>(((UnicharBufferImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIUnicharBuffer)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIUnicharBuffer*>(static_cast<UnicharBufferImpl*>(((UnicharBufferImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<UnicharBufferImpl*>(((UnicharBufferImpl*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const UnicharBufferImpl_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(UnicharBufferImpl)
    NS_IMPL_RELEASE(UnicharBufferImpl)
    

    enum nsSupportsVoidImpl_QIActionType {
      nsSupportsVoidImpl_OFFSET_THIS_ADDREF
    };

    struct nsSupportsVoidImpl_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsSupportsVoidImpl::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        2,
0xFF,
0xFF,
0xFF,
1,
0,
0xFF,
0xFF
#else
        2,
0xFF,
0xFF,
0xFF,
1,
0,
0xFF,
0xFF
#endif
      };

      static const nsSupportsVoidImpl_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISupportsPrimitive)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPrimitive*>(static_cast<nsSupportsVoidImpl*>(((nsSupportsVoidImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsVoidImpl*>(((nsSupportsVoidImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupportsVoid)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsVoid*>(static_cast<nsSupportsVoidImpl*>(((nsSupportsVoidImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsVoidImpl*>(((nsSupportsVoidImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsISupportsVoid*>(static_cast<nsSupportsVoidImpl*>(((nsSupportsVoidImpl*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsSupportsVoidImpl*>(((nsSupportsVoidImpl*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsSupportsVoidImpl_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_THREADSAFE_ADDREF(nsSupportsVoidImpl)
    NS_IMPL_THREADSAFE_RELEASE(nsSupportsVoidImpl)
    

    enum nsStaticAtomWrapper_QIActionType {
      nsStaticAtomWrapper_OFFSET_THIS_ADDREF
    };

    struct nsStaticAtomWrapper_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsStaticAtomWrapper::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        0,
0xFF,
0xFF,
0xFF,
1,
0xFF,
0xFF,
0xFF
#else
        0,
0xFF,
0xFF,
0xFF,
1,
0xFF,
0xFF,
0xFF
#endif
      };

      static const nsStaticAtomWrapper_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsIAtom*>(static_cast<nsStaticAtomWrapper*>(((nsStaticAtomWrapper*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsStaticAtomWrapper*>(((nsStaticAtomWrapper*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIAtom)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIAtom*>(static_cast<nsStaticAtomWrapper*>(((nsStaticAtomWrapper*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsStaticAtomWrapper*>(((nsStaticAtomWrapper*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsStaticAtomWrapper_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    enum nsArray_QIActionType {
      nsArray_OFFSET_THIS_ADDREF, nsArray_STATIC_POINTER, nsArray_CC_ISUPPORTS
    };

    struct nsArray_QIAction {
      const nsID *iid;
      nsArray_QIActionType action;
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsArray::QueryInterface(REFNSIID aIID, void **aResult)
    {
      
        #ifdef DEBUG
        static const nsID kGQI_nsCycleCollectionParticipant = { 0x9674489b, 0x1f6f, 0x4550, { 0xa7, 0x30, 0xcc, 0xae, 0xdd, 0x10, 0x4c, 0xf9 } };
        NS_ASSERTION(NS_GET_IID(nsCycleCollectionParticipant).Equals(kGQI_nsCycleCollectionParticipant),
                     "GQI pseudo-IID doesn't match reality.");
        #endif
        
        #ifdef DEBUG
        static const nsID kGQI_nsCycleCollectionISupports = { 0xc61eac14, 0x5f7a, 0x4481, { 0x96, 0x5e, 0x7e, 0xaa, 0x6e, 0xff, 0xa8, 0x5f } };
        NS_ASSERTION(NS_GET_IID(nsCycleCollectionISupports).Equals(kGQI_nsCycleCollectionISupports),
                     "GQI pseudo-IID doesn't match reality.");
        #endif
        

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        4,
3,
1,
2,
0xFF,
0xFF,
0xFF,
0
#else
        4,
3,
1,
2,
0xFF,
0xFF,
0xFF,
0
#endif
      };

      static const nsArray_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsIMutableArray)),
          nsArray_OFFSET_THIS_ADDREF,
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIMutableArray*>(static_cast<nsArray*>(((nsArray*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsArray*>(((nsArray*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsCycleCollectionParticipant)),
          nsArray_STATIC_POINTER,
          { &NS_CYCLE_COLLECTION_NAME(nsArray) }
        },
    
        {
          &(NS_GET_IID(nsCycleCollectionISupports)),
          nsArray_CC_ISUPPORTS,
          { 0 }
        },
    
        {
          &(NS_GET_IID(nsIArray)),
          nsArray_OFFSET_THIS_ADDREF,
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIArray*>(static_cast<nsArray*>(((nsArray*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsArray*>(((nsArray*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          nsArray_OFFSET_THIS_ADDREF,
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsIMutableArray*>(static_cast<nsArray*>(((nsArray*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsArray*>(((nsArray*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsArray_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c00) >> 10;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c00) >> 10;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
      switch (entry->action) {
      
      case nsArray_OFFSET_THIS_ADDREF:
        
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    
    
      case nsArray_STATIC_POINTER:
        *aResult = entry->data.ptr;
                   return NS_OK;
    
      case nsArray_CC_ISUPPORTS:
        
        found = NS_CYCLE_COLLECTION_CLASSNAME(nsArray)::Upcast(this);
        goto exit_nullcheck_addref;
    
    
      }
    

      NS_NOTREACHED("Unhandled case?");

      
    exit_nullcheck_addref:
      if (!found)
        return NS_ERROR_OUT_OF_MEMORY;
    

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    enum nsStringEnumerator_QIActionType {
      nsStringEnumerator_OFFSET_THIS_ADDREF
    };

    struct nsStringEnumerator_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsStringEnumerator::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        3,
2,
0xFF,
0xFF,
1,
0xFF,
0,
0xFF
#else
        3,
2,
0xFF,
0xFF,
1,
0xFF,
0,
0xFF
#endif
      };

      static const nsStringEnumerator_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsIStringEnumerator)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIStringEnumerator*>(static_cast<nsStringEnumerator*>(((nsStringEnumerator*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsStringEnumerator*>(((nsStringEnumerator*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISimpleEnumerator)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISimpleEnumerator*>(static_cast<nsStringEnumerator*>(((nsStringEnumerator*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsStringEnumerator*>(((nsStringEnumerator*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIUTF8StringEnumerator)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIUTF8StringEnumerator*>(static_cast<nsStringEnumerator*>(((nsStringEnumerator*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsStringEnumerator*>(((nsStringEnumerator*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsIStringEnumerator*>(static_cast<nsStringEnumerator*>(((nsStringEnumerator*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsStringEnumerator*>(((nsStringEnumerator*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsStringEnumerator_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x70) >> 4;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x70) >> 4;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(nsStringEnumerator)
    NS_IMPL_RELEASE(nsStringEnumerator)
    

    enum nsSimpleProperty_QIActionType {
      nsSimpleProperty_OFFSET_THIS_ADDREF
    };

    struct nsSimpleProperty_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsSimpleProperty::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        1,
0xFF,
0xFF,
0xFF,
0,
0xFF,
0xFF,
0xFF
#else
        1,
0xFF,
0xFF,
0xFF,
0,
0xFF,
0xFF,
0xFF
#endif
      };

      static const nsSimpleProperty_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsIProperty)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIProperty*>(static_cast<nsSimpleProperty*>(((nsSimpleProperty*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSimpleProperty*>(((nsSimpleProperty*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsIProperty*>(static_cast<nsSimpleProperty*>(((nsSimpleProperty*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsSimpleProperty*>(((nsSimpleProperty*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsSimpleProperty_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(nsSimpleProperty)
    NS_IMPL_RELEASE(nsSimpleProperty)
    

    enum nsSupportsInterfacePointerImpl_QIActionType {
      nsSupportsInterfacePointerImpl_OFFSET_THIS_ADDREF
    };

    struct nsSupportsInterfacePointerImpl_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsSupportsInterfacePointerImpl::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        1,
0xFF,
0xFF,
0xFF,
0,
0xFF,
2,
0xFF
#else
        1,
0xFF,
0xFF,
0xFF,
0,
0xFF,
2,
0xFF
#endif
      };

      static const nsSupportsInterfacePointerImpl_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISupportsInterfacePointer)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsInterfacePointer*>(static_cast<nsSupportsInterfacePointerImpl*>(((nsSupportsInterfacePointerImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsInterfacePointerImpl*>(((nsSupportsInterfacePointerImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsISupportsInterfacePointer*>(static_cast<nsSupportsInterfacePointerImpl*>(((nsSupportsInterfacePointerImpl*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsSupportsInterfacePointerImpl*>(((nsSupportsInterfacePointerImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupportsPrimitive)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPrimitive*>(static_cast<nsSupportsInterfacePointerImpl*>(((nsSupportsInterfacePointerImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsInterfacePointerImpl*>(((nsSupportsInterfacePointerImpl*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsSupportsInterfacePointerImpl_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x7) >> 0;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x7) >> 0;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_THREADSAFE_ADDREF(nsSupportsInterfacePointerImpl)
    NS_IMPL_THREADSAFE_RELEASE(nsSupportsInterfacePointerImpl)
    

    enum nsArrayEnumerator_QIActionType {
      nsArrayEnumerator_OFFSET_THIS_ADDREF
    };

    struct nsArrayEnumerator_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsArrayEnumerator::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        1,
0xFF,
0xFF,
0xFF,
0,
0xFF,
0xFF,
0xFF
#else
        1,
0xFF,
0xFF,
0xFF,
0,
0xFF,
0xFF,
0xFF
#endif
      };

      static const nsArrayEnumerator_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISimpleEnumerator)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISimpleEnumerator*>(static_cast<nsArrayEnumerator*>(((nsArrayEnumerator*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsArrayEnumerator*>(((nsArrayEnumerator*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsISimpleEnumerator*>(static_cast<nsArrayEnumerator*>(((nsArrayEnumerator*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsArrayEnumerator*>(((nsArrayEnumerator*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsArrayEnumerator_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x70) >> 4;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x70) >> 4;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(nsArrayEnumerator)
    NS_IMPL_RELEASE(nsArrayEnumerator)
    

    enum nsSupportsCharImpl_QIActionType {
      nsSupportsCharImpl_OFFSET_THIS_ADDREF
    };

    struct nsSupportsCharImpl_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsSupportsCharImpl::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        2,
0xFF,
0xFF,
0,
1,
0xFF,
0xFF,
0xFF
#else
        2,
0xFF,
0xFF,
0,
1,
0xFF,
0xFF,
0xFF
#endif
      };

      static const nsSupportsCharImpl_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISupportsPrimitive)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPrimitive*>(static_cast<nsSupportsCharImpl*>(((nsSupportsCharImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsCharImpl*>(((nsSupportsCharImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupportsChar)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsChar*>(static_cast<nsSupportsCharImpl*>(((nsSupportsCharImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsCharImpl*>(((nsSupportsCharImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsISupportsChar*>(static_cast<nsSupportsCharImpl*>(((nsSupportsCharImpl*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsSupportsCharImpl*>(((nsSupportsCharImpl*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsSupportsCharImpl_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x70) >> 4;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x70) >> 4;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(nsSupportsCharImpl)
    NS_IMPL_RELEASE(nsSupportsCharImpl)
    

    enum nsSupportsArrayEnumerator_QIActionType {
      nsSupportsArrayEnumerator_OFFSET_THIS_ADDREF
    };

    struct nsSupportsArrayEnumerator_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsSupportsArrayEnumerator::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        0,
0xFF,
0xFF,
0xFF,
1,
2,
0xFF,
0xFF
#else
        0,
0xFF,
0xFF,
0xFF,
1,
2,
0xFF,
0xFF
#endif
      };

      static const nsSupportsArrayEnumerator_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsIBidirectionalEnumerator*>(static_cast<nsSupportsArrayEnumerator*>(((nsSupportsArrayEnumerator*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsSupportsArrayEnumerator*>(((nsSupportsArrayEnumerator*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIEnumerator)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIEnumerator*>(static_cast<nsSupportsArrayEnumerator*>(((nsSupportsArrayEnumerator*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsArrayEnumerator*>(((nsSupportsArrayEnumerator*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIBidirectionalEnumerator)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIBidirectionalEnumerator*>(static_cast<nsSupportsArrayEnumerator*>(((nsSupportsArrayEnumerator*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsArrayEnumerator*>(((nsSupportsArrayEnumerator*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsSupportsArrayEnumerator_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0xe0) >> 5;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0xe0) >> 5;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(nsSupportsArrayEnumerator)
    NS_IMPL_RELEASE(nsSupportsArrayEnumerator)
    

    enum ByteBufferImpl_QIActionType {
      ByteBufferImpl_OFFSET_THIS_ADDREF
    };

    struct ByteBufferImpl_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP ByteBufferImpl::QueryInterface(REFNSIID aIID, void **aResult)
    {
      
        #ifdef DEBUG
        static const nsID kGQI_nsIByteBuffer = { 0xe4a6e4b0, 0x93b4, 0x11d1, { 0x89, 0x5b, 0x00, 0x60, 0x08, 0x91, 0x1b, 0x81 } };
        NS_ASSERTION(NS_GET_IID(nsIByteBuffer).Equals(kGQI_nsIByteBuffer),
                     "GQI pseudo-IID doesn't match reality.");
        #endif
        

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        0,
0xFF,
0xFF,
0xFF,
1,
0xFF,
0xFF,
0xFF
#else
        0,
0xFF,
0xFF,
0xFF,
1,
0xFF,
0xFF,
0xFF
#endif
      };

      static const ByteBufferImpl_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsIByteBuffer*>(static_cast<ByteBufferImpl*>(((ByteBufferImpl*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<ByteBufferImpl*>(((ByteBufferImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIByteBuffer)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIByteBuffer*>(static_cast<ByteBufferImpl*>(((ByteBufferImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<ByteBufferImpl*>(((ByteBufferImpl*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const ByteBufferImpl_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(ByteBufferImpl)
    NS_IMPL_RELEASE(ByteBufferImpl)
    

    enum nsSupportsPRUint64Impl_QIActionType {
      nsSupportsPRUint64Impl_OFFSET_THIS_ADDREF
    };

    struct nsSupportsPRUint64Impl_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsSupportsPRUint64Impl::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        1,
0xFF,
0xFF,
2,
0,
0xFF,
0xFF,
0xFF
#else
        1,
0xFF,
0xFF,
2,
0,
0xFF,
0xFF,
0xFF
#endif
      };

      static const nsSupportsPRUint64Impl_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISupportsPRUint64)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPRUint64*>(static_cast<nsSupportsPRUint64Impl*>(((nsSupportsPRUint64Impl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRUint64Impl*>(((nsSupportsPRUint64Impl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsISupportsPRUint64*>(static_cast<nsSupportsPRUint64Impl*>(((nsSupportsPRUint64Impl*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRUint64Impl*>(((nsSupportsPRUint64Impl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupportsPrimitive)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPrimitive*>(static_cast<nsSupportsPRUint64Impl*>(((nsSupportsPRUint64Impl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRUint64Impl*>(((nsSupportsPRUint64Impl*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsSupportsPRUint64Impl_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x70) >> 4;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x70) >> 4;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(nsSupportsPRUint64Impl)
    NS_IMPL_RELEASE(nsSupportsPRUint64Impl)
    

    enum nsSupportsPRUint16Impl_QIActionType {
      nsSupportsPRUint16Impl_OFFSET_THIS_ADDREF
    };

    struct nsSupportsPRUint16Impl_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsSupportsPRUint16Impl::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        2,
0xFF,
0xFF,
0xFF,
1,
0,
0xFF,
0xFF
#else
        2,
0xFF,
0xFF,
0xFF,
1,
0,
0xFF,
0xFF
#endif
      };

      static const nsSupportsPRUint16Impl_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISupportsPrimitive)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPrimitive*>(static_cast<nsSupportsPRUint16Impl*>(((nsSupportsPRUint16Impl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRUint16Impl*>(((nsSupportsPRUint16Impl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupportsPRUint16)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPRUint16*>(static_cast<nsSupportsPRUint16Impl*>(((nsSupportsPRUint16Impl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRUint16Impl*>(((nsSupportsPRUint16Impl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsISupportsPRUint16*>(static_cast<nsSupportsPRUint16Impl*>(((nsSupportsPRUint16Impl*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRUint16Impl*>(((nsSupportsPRUint16Impl*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsSupportsPRUint16Impl_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(nsSupportsPRUint16Impl)
    NS_IMPL_RELEASE(nsSupportsPRUint16Impl)
    

    enum nsSupportsPRUint32Impl_QIActionType {
      nsSupportsPRUint32Impl_OFFSET_THIS_ADDREF
    };

    struct nsSupportsPRUint32Impl_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsSupportsPRUint32Impl::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        2,
0xFF,
0xFF,
0xFF,
1,
0,
0xFF,
0xFF
#else
        2,
0xFF,
0xFF,
0xFF,
1,
0,
0xFF,
0xFF
#endif
      };

      static const nsSupportsPRUint32Impl_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISupportsPrimitive)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPrimitive*>(static_cast<nsSupportsPRUint32Impl*>(((nsSupportsPRUint32Impl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRUint32Impl*>(((nsSupportsPRUint32Impl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupportsPRUint32)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPRUint32*>(static_cast<nsSupportsPRUint32Impl*>(((nsSupportsPRUint32Impl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRUint32Impl*>(((nsSupportsPRUint32Impl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsISupportsPRUint32*>(static_cast<nsSupportsPRUint32Impl*>(((nsSupportsPRUint32Impl*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRUint32Impl*>(((nsSupportsPRUint32Impl*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsSupportsPRUint32Impl_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(nsSupportsPRUint32Impl)
    NS_IMPL_RELEASE(nsSupportsPRUint32Impl)
    

    enum nsINIParserFactory_QIActionType {
      nsINIParserFactory_OFFSET_THIS_ADDREF
    };

    struct nsINIParserFactory_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsINIParserFactory::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        2,
1,
0xFF,
0xFF,
0xFF,
0,
0xFF,
0xFF
#else
        2,
1,
0xFF,
0xFF,
0xFF,
0,
0xFF,
0xFF
#endif
      };

      static const nsINIParserFactory_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsIINIParserFactory)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIINIParserFactory*>(static_cast<nsINIParserFactory*>(((nsINIParserFactory*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsINIParserFactory*>(((nsINIParserFactory*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIFactory)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIFactory*>(static_cast<nsINIParserFactory*>(((nsINIParserFactory*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsINIParserFactory*>(((nsINIParserFactory*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsIINIParserFactory*>(static_cast<nsINIParserFactory*>(((nsINIParserFactory*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsINIParserFactory*>(((nsINIParserFactory*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsINIParserFactory_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x7) >> 0;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x7) >> 0;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(nsINIParserFactory)
    NS_IMPL_RELEASE(nsINIParserFactory)
    

    enum nsHashPropertyBag_QIActionType {
      nsHashPropertyBag_OFFSET_THIS_ADDREF
    };

    struct nsHashPropertyBag_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsHashPropertyBag::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        2,
0xFF,
3,
0,
1,
0xFF,
0xFF,
4
#else
        2,
0xFF,
3,
0,
1,
0xFF,
0xFF,
4
#endif
      };

      static const nsHashPropertyBag_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsIWritablePropertyBag2)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIWritablePropertyBag2*>(static_cast<nsHashPropertyBag*>(((nsHashPropertyBag*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsHashPropertyBag*>(((nsHashPropertyBag*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIWritablePropertyBag)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIWritablePropertyBag*>(static_cast<nsHashPropertyBag*>(((nsHashPropertyBag*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsHashPropertyBag*>(((nsHashPropertyBag*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsIWritablePropertyBag*>(static_cast<nsHashPropertyBag*>(((nsHashPropertyBag*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsHashPropertyBag*>(((nsHashPropertyBag*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIPropertyBag2)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIPropertyBag2*>(static_cast<nsHashPropertyBag*>(((nsHashPropertyBag*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsHashPropertyBag*>(((nsHashPropertyBag*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIPropertyBag)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIPropertyBag*>(
           static_cast<nsIWritablePropertyBag*>(static_cast<nsHashPropertyBag*>(((nsHashPropertyBag*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsHashPropertyBag*>(((nsHashPropertyBag*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsHashPropertyBag_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x380) >> 7;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x380) >> 7;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    enum nsSupportsPRInt16Impl_QIActionType {
      nsSupportsPRInt16Impl_OFFSET_THIS_ADDREF
    };

    struct nsSupportsPRInt16Impl_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsSupportsPRInt16Impl::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        2,
0xFF,
0xFF,
0xFF,
0,
1,
0xFF,
0xFF
#else
        2,
0xFF,
0xFF,
0xFF,
0,
1,
0xFF,
0xFF
#endif
      };

      static const nsSupportsPRInt16Impl_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISupportsPRInt16)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPRInt16*>(static_cast<nsSupportsPRInt16Impl*>(((nsSupportsPRInt16Impl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRInt16Impl*>(((nsSupportsPRInt16Impl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupportsPrimitive)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPrimitive*>(static_cast<nsSupportsPRInt16Impl*>(((nsSupportsPRInt16Impl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRInt16Impl*>(((nsSupportsPRInt16Impl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsISupportsPRInt16*>(static_cast<nsSupportsPRInt16Impl*>(((nsSupportsPRInt16Impl*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRInt16Impl*>(((nsSupportsPRInt16Impl*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsSupportsPRInt16Impl_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(nsSupportsPRInt16Impl)
    NS_IMPL_RELEASE(nsSupportsPRInt16Impl)
    

    enum nsSupportsDependentCString_QIActionType {
      nsSupportsDependentCString_OFFSET_THIS_ADDREF
    };

    struct nsSupportsDependentCString_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsSupportsDependentCString::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        2,
0xFF,
0xFF,
0xFF,
0,
1,
0xFF,
0xFF
#else
        2,
0xFF,
0xFF,
0xFF,
0,
1,
0xFF,
0xFF
#endif
      };

      static const nsSupportsDependentCString_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISupportsCString)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsCString*>(static_cast<nsSupportsDependentCString*>(((nsSupportsDependentCString*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsDependentCString*>(((nsSupportsDependentCString*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupportsPrimitive)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPrimitive*>(static_cast<nsSupportsDependentCString*>(((nsSupportsDependentCString*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsDependentCString*>(((nsSupportsDependentCString*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsISupportsCString*>(static_cast<nsSupportsDependentCString*>(((nsSupportsDependentCString*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsSupportsDependentCString*>(((nsSupportsDependentCString*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsSupportsDependentCString_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(nsSupportsDependentCString)
    NS_IMPL_RELEASE(nsSupportsDependentCString)
    

    enum nsSupportsStringImpl_QIActionType {
      nsSupportsStringImpl_OFFSET_THIS_ADDREF
    };

    struct nsSupportsStringImpl_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsSupportsStringImpl::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        2,
0xFF,
0xFF,
0xFF,
0,
1,
0xFF,
0xFF
#else
        2,
0xFF,
0xFF,
0xFF,
0,
1,
0xFF,
0xFF
#endif
      };

      static const nsSupportsStringImpl_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISupportsString)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsString*>(static_cast<nsSupportsStringImpl*>(((nsSupportsStringImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsStringImpl*>(((nsSupportsStringImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupportsPrimitive)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPrimitive*>(static_cast<nsSupportsStringImpl*>(((nsSupportsStringImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsStringImpl*>(((nsSupportsStringImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsISupportsString*>(static_cast<nsSupportsStringImpl*>(((nsSupportsStringImpl*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsSupportsStringImpl*>(((nsSupportsStringImpl*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsSupportsStringImpl_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(nsSupportsStringImpl)
    NS_IMPL_RELEASE(nsSupportsStringImpl)
    

    enum AtomImpl_QIActionType {
      AtomImpl_OFFSET_THIS_ADDREF
    };

    struct AtomImpl_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP AtomImpl::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        0,
0xFF,
0xFF,
0xFF,
1,
0xFF,
0xFF,
0xFF
#else
        0,
0xFF,
0xFF,
0xFF,
1,
0xFF,
0xFF,
0xFF
#endif
      };

      static const AtomImpl_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsIAtom*>(static_cast<AtomImpl*>(((AtomImpl*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<AtomImpl*>(((AtomImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIAtom)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIAtom*>(static_cast<AtomImpl*>(((AtomImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<AtomImpl*>(((AtomImpl*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const AtomImpl_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(AtomImpl)
    NS_IMPL_RELEASE(AtomImpl)
    

    enum nsSupportsPRUint8Impl_QIActionType {
      nsSupportsPRUint8Impl_OFFSET_THIS_ADDREF
    };

    struct nsSupportsPRUint8Impl_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsSupportsPRUint8Impl::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        1,
0xFF,
0xFF,
0xFF,
2,
0xFF,
0,
0xFF
#else
        1,
0xFF,
0xFF,
0xFF,
2,
0xFF,
0,
0xFF
#endif
      };

      static const nsSupportsPRUint8Impl_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISupportsPrimitive)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPrimitive*>(static_cast<nsSupportsPRUint8Impl*>(((nsSupportsPRUint8Impl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRUint8Impl*>(((nsSupportsPRUint8Impl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsISupportsPRUint8*>(static_cast<nsSupportsPRUint8Impl*>(((nsSupportsPRUint8Impl*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRUint8Impl*>(((nsSupportsPRUint8Impl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupportsPRUint8)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPRUint8*>(static_cast<nsSupportsPRUint8Impl*>(((nsSupportsPRUint8Impl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRUint8Impl*>(((nsSupportsPRUint8Impl*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsSupportsPRUint8Impl_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x38) >> 3;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x38) >> 3;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(nsSupportsPRUint8Impl)
    NS_IMPL_RELEASE(nsSupportsPRUint8Impl)
    

    enum nsSupportsFloatImpl_QIActionType {
      nsSupportsFloatImpl_OFFSET_THIS_ADDREF
    };

    struct nsSupportsFloatImpl_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsSupportsFloatImpl::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        2,
0xFF,
0xFF,
0xFF,
0,
1,
0xFF,
0xFF
#else
        2,
0xFF,
0xFF,
0xFF,
0,
1,
0xFF,
0xFF
#endif
      };

      static const nsSupportsFloatImpl_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISupportsFloat)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsFloat*>(static_cast<nsSupportsFloatImpl*>(((nsSupportsFloatImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsFloatImpl*>(((nsSupportsFloatImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupportsPrimitive)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPrimitive*>(static_cast<nsSupportsFloatImpl*>(((nsSupportsFloatImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsFloatImpl*>(((nsSupportsFloatImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsISupportsFloat*>(static_cast<nsSupportsFloatImpl*>(((nsSupportsFloatImpl*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsSupportsFloatImpl*>(((nsSupportsFloatImpl*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsSupportsFloatImpl_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(nsSupportsFloatImpl)
    NS_IMPL_RELEASE(nsSupportsFloatImpl)
    

    enum nsPersistentProperties_QIActionType {
      nsPersistentProperties_OFFSET_THIS_ADDREF
    };

    struct nsPersistentProperties_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsPersistentProperties::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        2,
0xFF,
0xFF,
0,
1,
0xFF,
0xFF,
0xFF
#else
        2,
0xFF,
0xFF,
0,
1,
0xFF,
0xFF,
0xFF
#endif
      };

      static const nsPersistentProperties_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsIPersistentProperties)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIPersistentProperties*>(static_cast<nsPersistentProperties*>(((nsPersistentProperties*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsPersistentProperties*>(((nsPersistentProperties*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIProperties)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIProperties*>(static_cast<nsPersistentProperties*>(((nsPersistentProperties*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsPersistentProperties*>(((nsPersistentProperties*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsIPersistentProperties*>(static_cast<nsPersistentProperties*>(((nsPersistentProperties*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsPersistentProperties*>(((nsPersistentProperties*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsPersistentProperties_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0xe0) >> 5;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0xe0) >> 5;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_THREADSAFE_ADDREF(nsPersistentProperties)
    NS_IMPL_THREADSAFE_RELEASE(nsPersistentProperties)
    

    enum nsObserverEnumerator_QIActionType {
      nsObserverEnumerator_OFFSET_THIS_ADDREF
    };

    struct nsObserverEnumerator_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsObserverEnumerator::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        1,
0xFF,
0xFF,
0xFF,
0,
0xFF,
0xFF,
0xFF
#else
        1,
0xFF,
0xFF,
0xFF,
0,
0xFF,
0xFF,
0xFF
#endif
      };

      static const nsObserverEnumerator_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISimpleEnumerator)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISimpleEnumerator*>(static_cast<nsObserverEnumerator*>(((nsObserverEnumerator*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsObserverEnumerator*>(((nsObserverEnumerator*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsISimpleEnumerator*>(static_cast<nsObserverEnumerator*>(((nsObserverEnumerator*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsObserverEnumerator*>(((nsObserverEnumerator*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsObserverEnumerator_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x70) >> 4;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x70) >> 4;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(nsObserverEnumerator)
    NS_IMPL_RELEASE(nsObserverEnumerator)
    

    enum nsPropertyElement_QIActionType {
      nsPropertyElement_OFFSET_THIS_ADDREF
    };

    struct nsPropertyElement_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsPropertyElement::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        1,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF,
0,
0xFF
#else
        1,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF,
0,
0xFF
#endif
      };

      static const nsPropertyElement_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsIPropertyElement)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIPropertyElement*>(static_cast<nsPropertyElement*>(((nsPropertyElement*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsPropertyElement*>(((nsPropertyElement*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsIPropertyElement*>(static_cast<nsPropertyElement*>(((nsPropertyElement*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsPropertyElement*>(((nsPropertyElement*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsPropertyElement_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x7) >> 0;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x7) >> 0;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(nsPropertyElement)
    NS_IMPL_RELEASE(nsPropertyElement)
    

    enum nsINIParserImpl_QIActionType {
      nsINIParserImpl_OFFSET_THIS_ADDREF
    };

    struct nsINIParserImpl_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsINIParserImpl::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        1,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF,
0,
0xFF
#else
        1,
0xFF,
0xFF,
0xFF,
0xFF,
0xFF,
0,
0xFF
#endif
      };

      static const nsINIParserImpl_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsIINIParser)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIINIParser*>(static_cast<nsINIParserImpl*>(((nsINIParserImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsINIParserImpl*>(((nsINIParserImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsIINIParser*>(static_cast<nsINIParserImpl*>(((nsINIParserImpl*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsINIParserImpl*>(((nsINIParserImpl*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsINIParserImpl_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x7) >> 0;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x7) >> 0;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(nsINIParserImpl)
    NS_IMPL_RELEASE(nsINIParserImpl)
    

    enum nsSupportsCStringImpl_QIActionType {
      nsSupportsCStringImpl_OFFSET_THIS_ADDREF
    };

    struct nsSupportsCStringImpl_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsSupportsCStringImpl::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        2,
0xFF,
0xFF,
0xFF,
0,
1,
0xFF,
0xFF
#else
        2,
0xFF,
0xFF,
0xFF,
0,
1,
0xFF,
0xFF
#endif
      };

      static const nsSupportsCStringImpl_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISupportsCString)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsCString*>(static_cast<nsSupportsCStringImpl*>(((nsSupportsCStringImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsCStringImpl*>(((nsSupportsCStringImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupportsPrimitive)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPrimitive*>(static_cast<nsSupportsCStringImpl*>(((nsSupportsCStringImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsCStringImpl*>(((nsSupportsCStringImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsISupportsCString*>(static_cast<nsSupportsCStringImpl*>(((nsSupportsCStringImpl*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsSupportsCStringImpl*>(((nsSupportsCStringImpl*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsSupportsCStringImpl_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(nsSupportsCStringImpl)
    NS_IMPL_RELEASE(nsSupportsCStringImpl)
    

    enum nsSupportsPRTimeImpl_QIActionType {
      nsSupportsPRTimeImpl_OFFSET_THIS_ADDREF
    };

    struct nsSupportsPRTimeImpl_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsSupportsPRTimeImpl::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        1,
0xFF,
0xFF,
0xFF,
2,
0,
0xFF,
0xFF
#else
        1,
0xFF,
0xFF,
0xFF,
2,
0,
0xFF,
0xFF
#endif
      };

      static const nsSupportsPRTimeImpl_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISupportsPrimitive)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPrimitive*>(static_cast<nsSupportsPRTimeImpl*>(((nsSupportsPRTimeImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRTimeImpl*>(((nsSupportsPRTimeImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsISupportsPRTime*>(static_cast<nsSupportsPRTimeImpl*>(((nsSupportsPRTimeImpl*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRTimeImpl*>(((nsSupportsPRTimeImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupportsPRTime)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPRTime*>(static_cast<nsSupportsPRTimeImpl*>(((nsSupportsPRTimeImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRTimeImpl*>(((nsSupportsPRTimeImpl*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsSupportsPRTimeImpl_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(nsSupportsPRTimeImpl)
    NS_IMPL_RELEASE(nsSupportsPRTimeImpl)
    

    enum nsVariant_QIActionType {
      nsVariant_OFFSET_THIS_ADDREF
    };

    struct nsVariant_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsVariant::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        1,
0xFF,
0,
0xFF,
2,
0xFF,
0xFF,
0xFF
#else
        1,
0xFF,
0,
0xFF,
2,
0xFF,
0xFF,
0xFF
#endif
      };

      static const nsVariant_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsIWritableVariant)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIWritableVariant*>(static_cast<nsVariant*>(((nsVariant*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsVariant*>(((nsVariant*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsIVariant*>(static_cast<nsVariant*>(((nsVariant*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsVariant*>(((nsVariant*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsIVariant)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsIVariant*>(static_cast<nsVariant*>(((nsVariant*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsVariant*>(((nsVariant*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsVariant_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x38) >> 3;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x38) >> 3;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(nsVariant)
    NS_IMPL_RELEASE(nsVariant)
    

    enum nsSupportsIDImpl_QIActionType {
      nsSupportsIDImpl_OFFSET_THIS_ADDREF
    };

    struct nsSupportsIDImpl_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsSupportsIDImpl::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        2,
0xFF,
0xFF,
0xFF,
0,
0xFF,
1,
0xFF
#else
        2,
0xFF,
0xFF,
0xFF,
0,
0xFF,
1,
0xFF
#endif
      };

      static const nsSupportsIDImpl_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISupportsID)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsID*>(static_cast<nsSupportsIDImpl*>(((nsSupportsIDImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsIDImpl*>(((nsSupportsIDImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupportsPrimitive)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPrimitive*>(static_cast<nsSupportsIDImpl*>(((nsSupportsIDImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsIDImpl*>(((nsSupportsIDImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsISupportsID*>(static_cast<nsSupportsIDImpl*>(((nsSupportsIDImpl*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsSupportsIDImpl*>(((nsSupportsIDImpl*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsSupportsIDImpl_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x38) >> 3;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x38) >> 3;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(nsSupportsIDImpl)
    NS_IMPL_RELEASE(nsSupportsIDImpl)
    

    enum nsSupportsPRInt32Impl_QIActionType {
      nsSupportsPRInt32Impl_OFFSET_THIS_ADDREF
    };

    struct nsSupportsPRInt32Impl_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsSupportsPRInt32Impl::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        2,
0xFF,
0xFF,
0xFF,
1,
0,
0xFF,
0xFF
#else
        2,
0xFF,
0xFF,
0xFF,
1,
0,
0xFF,
0xFF
#endif
      };

      static const nsSupportsPRInt32Impl_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISupportsPrimitive)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPrimitive*>(static_cast<nsSupportsPRInt32Impl*>(((nsSupportsPRInt32Impl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRInt32Impl*>(((nsSupportsPRInt32Impl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupportsPRInt32)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPRInt32*>(static_cast<nsSupportsPRInt32Impl*>(((nsSupportsPRInt32Impl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRInt32Impl*>(((nsSupportsPRInt32Impl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsISupportsPRInt32*>(static_cast<nsSupportsPRInt32Impl*>(((nsSupportsPRInt32Impl*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRInt32Impl*>(((nsSupportsPRInt32Impl*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsSupportsPRInt32Impl_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(nsSupportsPRInt32Impl)
    NS_IMPL_RELEASE(nsSupportsPRInt32Impl)
    

    enum nsSupportsDoubleImpl_QIActionType {
      nsSupportsDoubleImpl_OFFSET_THIS_ADDREF
    };

    struct nsSupportsDoubleImpl_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsSupportsDoubleImpl::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        2,
0xFF,
0xFF,
0xFF,
1,
0xFF,
0,
0xFF
#else
        2,
0xFF,
0xFF,
0xFF,
1,
0xFF,
0,
0xFF
#endif
      };

      static const nsSupportsDoubleImpl_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISupportsPrimitive)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPrimitive*>(static_cast<nsSupportsDoubleImpl*>(((nsSupportsDoubleImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsDoubleImpl*>(((nsSupportsDoubleImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupportsDouble)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsDouble*>(static_cast<nsSupportsDoubleImpl*>(((nsSupportsDoubleImpl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsDoubleImpl*>(((nsSupportsDoubleImpl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsISupportsDouble*>(static_cast<nsSupportsDoubleImpl*>(((nsSupportsDoubleImpl*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsSupportsDoubleImpl*>(((nsSupportsDoubleImpl*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsSupportsDoubleImpl_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x38) >> 3;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x38) >> 3;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(nsSupportsDoubleImpl)
    NS_IMPL_RELEASE(nsSupportsDoubleImpl)
    

    enum nsSupportsPRInt64Impl_QIActionType {
      nsSupportsPRInt64Impl_OFFSET_THIS_ADDREF
    };

    struct nsSupportsPRInt64Impl_QIAction {
      const nsID *iid;
      
      union {
        void *ptr;
        
        PRUint32 offset;
    
      } data;
    };

    NS_IMETHODIMP nsSupportsPRInt64Impl::QueryInterface(REFNSIID aIID, void **aResult)
    {
      

      static const PRUint8 kLookupTable[] = {
#ifdef IS_BIG_ENDIAN
        1,
0xFF,
0xFF,
0xFF,
2,
0,
0xFF,
0xFF
#else
        1,
0xFF,
0xFF,
0xFF,
2,
0,
0xFF,
0xFF
#endif
      };

      static const nsSupportsPRInt64Impl_QIAction kActionTable[] = {
        
        {
          &(NS_GET_IID(nsISupportsPrimitive)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPrimitive*>(static_cast<nsSupportsPRInt64Impl*>(((nsSupportsPRInt64Impl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRInt64Impl*>(((nsSupportsPRInt64Impl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupports)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupports*>(
           static_cast<nsISupportsPRInt64*>(static_cast<nsSupportsPRInt64Impl*>(((nsSupportsPRInt64Impl*) 0x1000))))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRInt64Impl*>(((nsSupportsPRInt64Impl*) 0x1000))))
   }
        },
    
        {
          &(NS_GET_IID(nsISupportsPRInt64)),
          
          
   { reinterpret_cast<void*>(
       reinterpret_cast<char*>(
         static_cast<nsISupportsPRInt64*>(static_cast<nsSupportsPRInt64Impl*>(((nsSupportsPRInt64Impl*) 0x1000)))) -
       reinterpret_cast<char*>(static_cast<nsSupportsPRInt64Impl*>(((nsSupportsPRInt64Impl*) 0x1000))))
   }
        },
    
      };

      nsISupports* found = nsnull;
      const nsSupportsPRInt64Impl_QIAction *entry;
      PRUint32 index =
#ifdef IS_BIG_ENDIAN
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#else
        (reinterpret_cast<const PRUint32*>(&aIID)[0] & 0x1c) >> 2;
#endif

      PRUint8 action = kLookupTable[index];
      if (action == 0xFF)
        goto unfound;

      entry = kActionTable + action;
      if (!entry->iid->Equals(aIID))
        goto unfound;

      
        found = reinterpret_cast<nsISupports*>(reinterpret_cast<char*>(this) + entry->data.offset);
        goto exit_addref;
    

      NS_NOTREACHED("Unhandled case?");

      

    exit_addref:
      NS_ASSERTION(found, "Interface should have been found by now.");
      found->AddRef();
      *aResult = found;
      return NS_OK;

    unfound:
      
      *aResult = nsnull;
      return NS_NOINTERFACE;
    
    }

    NS_IMPL_ADDREF(nsSupportsPRInt64Impl)
    NS_IMPL_RELEASE(nsSupportsPRInt64Impl)
    
